package com.tanpu.community.dao.mapper.community;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.tanpu.community.dao.entity.community.TimesCountEntity;
import com.tanpu.community.dao.entity.community.VisitSummaryEntity;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 浏览记录 Mapper 接口
 * </p>
 *
 * @author xudong
 * @since 2021-07-22
 */
public interface VisitSummaryMapper extends BaseMapper<VisitSummaryEntity> {
    @Select("select * from visit_summary where ident=#{ident}")
    VisitSummaryEntity selectByIdent(@Param("ident") String ident);

    @Update("update visit_summary set duration=duration+#{duration} where ident=#{ident}")
    void updateDurByIdent(@Param("duration") Integer dur, @Param("ident") String ident);

    @Select("select ref_id from visit_summary where visitor_id=#{visitorId} and ref_id in (#{refIds})")
    List<String> selectRefIdByUserId(@Param("visitorId") String visitorId, @Param("refIds") String refIds);

    @Select("select ref_id as id,  count(1) as times from visit_summary ${ew.customSqlSegment}")
    List<TimesCountEntity> selectCountByThemeIds(@Param(Constants.WRAPPER)LambdaQueryWrapper wrapper);

    @Select("select ref_id from visit_summary where visitor_id=#{visitorId} and date(create_time) between #{startDate} and #{endDate}")
    List<String> selectRefIdByUserIdAndCreateBetween(@Param("visitorId") String visitorId, @Param("startDate") Date startDate, @Param("endDate") Date endDate);
}
